<?php

/***********************************/
/* Debug : uncomment to display all errors and warnings */
//error_reporting(E_ALL && ~E_NOTICE);
/***********************************/


/***********************************/
/* Script root path */
$dir = dirname(__FILE__);
$dir = ereg_replace(".members","",$dir);
define("SCRIPT_ROOT_PATH",$dir);
/***********************************/


/***********************************/
/* Share directory */
define("SHARE_DIR",$dir.'/share');
/***********************************/


/***********************************/
/* configuration file and main functions */
require_once(SCRIPT_ROOT_PATH.'/class/class.config.php');
$config_manager =& MyconfigManager::getInstance();

if(!$config_manager->loadConfig())
{
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	echo "<html><head><title>Install</title></head>";
	if(is_writable(SCRIPT_ROOT_PATH.'/templates_c'))
	{
		echo "<h4 align='center' style='color: red;'>FreeGlobes is ready for setup...</h4>\n<h3 align='center'>&gt;&gt; <a href=\"../install/\">Go to Setup</a> &lt;&lt;</h3>";
	}
	else
	{
		echo "<h4 align='center' style='color: red;'>Please CHMOD 777 this directory : '/templates_c'</h4>\n";
		echo "\n<h3 align='center'>&gt;&gt; <a href='.'>Refresh</a> &lt;&lt;</h3>";
	}
	exit();
}
$CONFIG =& $config_manager->getConfig();
/***********************************/


/***********************************/
/*Common functions */
require_once(SCRIPT_ROOT_PATH.'/admin/include/common.php');
require_once(SCRIPT_ROOT_PATH.'/include/common.php');
/***********************************/


/***********************************/
/* Benchmark Utility */
require_once(SCRIPT_ROOT_PATH.'/class/class.bench.php');
$bench = new Bench();
$bench->startBench();
/***********************************/


/***********************************/
/* Smarty Engine */
require_once(SCRIPT_ROOT_PATH.'/class/class.templateengine.php');

$template_dir = SCRIPT_ROOT_PATH."/themes/members";
$theme_dir = $CONFIG['site_url']."/themes/members";

$smarty =& TemplateEngine::getInstance();

$smarty->template_dir = $template_dir;

$smarty->assign("CONFIG",$CONFIG);
$smarty->assign("theme_dir",$theme_dir);

$smarty->load_filter('output','trimwhitespace');
/***********************************/



/***********************************/
/* Text Sanitizer */
require_once(SCRIPT_ROOT_PATH.'/class/class.textsanitizer.php');
// Texte sanitizer
$myts =& MyTextSanitizer::getInstance();
/***********************************/


/***********************************/
/* Cache ID */
require_once(SCRIPT_ROOT_PATH.'/class/class.cacheid.php');
$cache_id = CacheID::generate();
/***********************************/


/***********************************/
/* Database */
include_once(SCRIPT_ROOT_PATH.'/class/database/class.databasefactory.php');
/***********************************/

/***********************************/
/* Plugins */
require_once(SCRIPT_ROOT_PATH.'/class/class.plugins.php');
require_once(SCRIPT_ROOT_PATH.'/class/libs/lib.form.php');
/***********************************/


/***********************************/
/* Loading MyDirectory class*/
require_once (SCRIPT_ROOT_PATH.'/class/class.dir.php');
/***********************************/


/***********************************/
/* Language manager */
require_once(SCRIPT_ROOT_PATH.'/class/class.languagemanager.php');
$langmanager = new LanguageManager(SCRIPT_ROOT_PATH.'/language/', $CONFIG['language'], 'user.php');
$langmanager->loadLang();
/***********************************/


/***********************************/
/* Authentification */
require_once (SCRIPT_ROOT_PATH.'/class/auth/class.authfactory.php');
/***********************************/


/***********************************/
/* Loading WYSIWYG editor */
require_once(SCRIPT_ROOT_PATH.'/class/class.fckeditor.php');
/***********************************/


/***********************************/
/* Loading Charts */
require_once(SCRIPT_ROOT_PATH.'/members/include/charts.php');
define('FLASH_FILE',$theme_dir.'/swf/charts.swf');
define('LIBRARY_PATH',$theme_dir.'/swf/charts_library');
/***********************************/


/***********************************/
/* Mail Manager */
require_once SCRIPT_ROOT_PATH.'/class/class.mailmanager.php';
/***********************************/

?>