<?php

define('ALLOPASS_DOC_ID','MTIwMDk2LzMyNDc2NC8yMDg5NzUw');
define('ALLOPASS_AP_CA_IDC0',$CONFIG['allopass_ID']);
define('ALLOPASS_AP_CA_MNT0','#fg');
define('ALLOPASS_MAX_TIME',3);
define('ALLOPASS_DEFAULT_ERROR_PAGE',$CONFIG['site_url']);
define('ALLOPASS_DEFAULT_SUCCESS_PAGE',$CONFIG['site_url']);

/*
*	Burns and checks an allopass code; redirects to error page if invalid code
*	@class	AllopassChecker
*
*/
class AllopassChecker
{
	/*
	*	"Burns" the code entered by the user
	*	@func	burnCode
	*	@return	boolean
	*/
	function burnCode($code,$SITE_ID,$DOC_ID)
	{
		$request = "http://www.allopass.com/check/index.php4?";
		$request .= "SITE_ID=".$SITE_ID;
		$request .= "&DOC_ID=".$DOC_ID;
		$request .= "&CODE=".$code;
		$request .= "&AP_CA_IDC0=".ALLOPASS_AP_CA_IDC0;
		$request .= "&AP_CA_MNT0=".urlencode(ALLOPASS_AP_CA_MNT0);
		
		return @file($request);
	}

	/*
	*	This function make the operation the allopass form says him to do
	*	@func	doOperation
	*	@return	string
	*/
	function CreatePremiumAccess()
	{
		global $CONFIG, $lang;
		$do = isset($_POST['do']) ? $_POST['do'] : '';
		$ip = $_SERVER['REMOTE_ADDR'];
		$code = isset($_POST['CODE']) ? $_POST['CODE'] : '';
		
		$str = '<div align="center">';
		
		$am =& get_manager('allopass');
		
		// Write user ip in allopass table to allow him to access to protected pages
		$criteria = new CriteriaCompo(new Criteria('ip',$ip,'='),'AND');
		$criteria->add(new Criteria('code',$code,'='),'AND');
		$criteria->add(new Criteria('action',$do,'='),'AND');
		$criteria->setLimit(1);
		
		$count = $am->getCount($criteria);
		
		if($count == 0)
		{
			// User has not entered this code before
			$allopass = $am->create(true);
			
			$attributes = array('ip' => $ip, 
								'code' => $code, 
								'action' => $do, 
								'date' => time());
								
			$allopass->setVars($attributes);
			$allopass->setNew();
			
			$am->insert($allopass);
		}
		else
		{
			// this case is not possible because that means user has burned more than one time the same code
		}
		
		$str .= '</div>';
		
		return $str;
	}
	
	/*
	*	Redirects user to error page specified in check code template tag
	*	@func	displayErrorPage
	*	@param	string	error page
	*	@return	void
	*/
	function displayErrorPage($error_page)
	{
		global $CONFIG;
		$header = $error_page;
		header('Location: '.$header);
		exit();
	}
	
	/*
	*	returns ALLOPASS_DOC_ID decoded only
	*	@func	decodeDocId()
	*	@return	string	decoded ALLOPASS_DOC_ID
	*/
	function getDocId()
	{
		return base64_decode(ALLOPASS_DOC_ID);
	}
	
	/*
	*	returns ALLOPASS_DOC_ID decoded and exploded
	*	@func	decodeDocId()
	*	@return	string	decoded ALLOPASS_DOC_ID
	*/
	function getExplodedDocId()
	{
		return explode('/',AllopassChecker::getDocId());
	}
}

/*
*	Checks if Allopass code is correct and redirect user to error page if there is an error
*	template code : <{plugin name='allopass' call='checkCode' parameters="user/index.php?cat=buypoints&err=1"}>
*
*	@func	checkCode
*	@return	string	output
*/
function checkCode($p = array())
{
	global $CONFIG, $lang;
	// Default error page : user/index.php?cat=buypoints&err=1
	$error_page = isset($p[0]) ? $p[0] : ALLOPASS_DEFAULT_ERROR_PAGE;
	
	$ip = $_SERVER['REMOTE_ADDR'];
	$now = time();
	$expiration_time = $CONFIG['allopass_expiration_time'];
	$do = isset($_POST['do']) ? $_POST['do'] : '';
	
	$am =& get_manager('allopass');
	
	$criteria = new CriteriaCompo(new Criteria('ip',$ip,'='),'AND');
	$criteria->add(new Criteria('date',$now - $expiration_time,'>='),'AND');
	$criteria->add(new Criteria('action',$do,'='),'AND');
	$criteria->setLimit(1);
	
	$count = $am->getCount($criteria);
	
	if($count == 0)
	{
		$str = '';
		$code = isset($_POST['CODE']) ? $_POST['CODE'] : '';
		list($SITE_ID,$DOC_ID,$AUTH) = AllopassChecker::getExplodedDocId();
		
		if(!empty($code))
		{
			if(AllopassChecker::burnCode($code,$SITE_ID,$DOC_ID))
			{
				$request = "http://www.allopass.com/check/vf.php4?";
				$request .= "AUTH=".urlencode(AllopassChecker::getDocId());
				$request .= "&CODE=".$code;
				$request .= "&MAXT=".ALLOPASS_MAX_TIME;
				
				$result = @file($request);
				
				$operation_code = isset($result[0]) ? $result[0] : 'NOK';
				
				if (ereg("ERR",$result[0]) || ereg("NOK",$result[0]))
				{
					// Code is false
					AllopassChecker::displayErrorPage($error_page);
				}
				else
				{
					// Burned Code OK
					AllopassChecker::CreatePremiumAccess();
				}
			}
			else
			{
				// Code not burned
				AllopassChecker::displayErrorPage($error_page);
			}
		}
		else
		{
			// Empty Code : redirect user to error page
			AllopassChecker::displayErrorPage($error_page);
		}
	}
	else
	{
		// User has already a premium IP session logued
	}
}

/*
*	Protects a page accessible only by allopass with IP Lock. this is useful when you have a couple
*	of pages and you want to protect them against allopass hacking
*	Template Tag : <{plugin name="allopass" call="ipLock" parameters="user/index.php,"}>
*	This template code locks the page, and redirects to 404 not found if ip not found
*	@func	ipLock
*	@param	array	p
*	@return	void
*/
function ipLock($p = array())
{
	global $CONFIG;
	$action = isset($p[0]) ? $p[0] : '';
	$error_page = isset($p[1]) ? $p[1] : ALLOPASS_DEFAULT_ERROR_PAGE;
	$ip = $_SERVER['REMOTE_ADDR'];
	$now = time();
	$expiration_time = $CONFIG['allopass_expiration_time'];

	$am =& get_manager('allopass');
	
	$criteria = new CriteriaCompo(new Criteria('ip',$ip,'='),'AND');
	$criteria->add(new Criteria('date',$now - $expiration_time,'>='),'AND');
	$criteria->add(new Criteria('action',$action,'='),'AND');
	$criteria->setLimit(1);
	
	$count = $am->getCount($criteria);
	
	if($count == 0)
	{
		// IP Address is not valid : This IP hasn't entered any code within expiration time
		// Raising 404 error
		AllopassChecker::displayErrorPage($error_page);
	}
	else
	{
		// IP not locked : This user entered an Allopass within the expiration time
	}
}

/*
*	Does the specified action if premium access is valid
*	@func	doAction
*	@param	array p : 0 => action to perform
*	@return	void
*/
function doAction($p = array())
{
	global $CONFIG;
	
	$action = isset($p[0]) ? $p[0] : '';
	$ip = $_SERVER['REMOTE_ADDR'];
	$now = time();
	$expiration_time = $CONFIG['allopass_expiration_time'];
	
	$error_page = ALLOPASS_DEFAULT_ERROR_PAGE;
	$success_page = ALLOPASS_DEFAULT_SUCCESS_PAGE;
	
	$am =& get_manager('allopass');
	
	if($am->hasPremiumAccess($action))
	{
		switch($action)
		{
			case 'buyPoints':
				$success_page = 'user/index.php?cat=buypoints&success=1';
				$um =& get_manager('user');
				
				$criteria = new Criteria('id',$um->myUID(),'=');
				$criteria->setLimit(1);
				$um->incrementPoints($criteria,$CONFIG['points_attributed_by_allopass']);
				
				$am->deletePremiumAccess($action);
				break;
		}
		
		
		header('Location: '.$CONFIG['site_url'].'/'.$success_page);
		exit();
	}
	else
	{
		switch($action)
		{
			case 'buyPoints':
				$error_page = 'user/index.php?cat=buypoints&err=1';
				break;
		}
		
		header('Location: '.$CONFIG['site_url'].'/'.$error_page);
		exit();
	}
}

/*
*	Prints Allopass Form
*	Template code example : <{plugin name='allopass' call='displayForm' parameters="user/index.php?cat=allopass,buyPoints"}>
*	parameters :	0 => user/index.php?cat=allopass : URL of the page which checks the allopass code
*				1 => action to perform (done in AllopassChecker::doOperation()) if code is OK
*				2 => page vers laquelle rediriger si le code est deja ok
*
*	@func	displayForm
*	@param	Array	p
*	@return	void (displays content)
*/
function displayForm($p = array())
{
	global $CONFIG,$lang;
	
	$form_action_page = isset($p[0]) ? $p[0] : 'user/index.php?cat=allopass';
	$do = isset($p[1]) ? $p[1] : 'buyPoints';
	
	$first_premium_page = isset($p[2]) ? $p[2] : 'index.php?do=premium';
	$ip = $_SERVER['REMOTE_ADDR'];
	$now = time();
	$expiration_time = $CONFIG['allopass_expiration_time'];

	$am =& get_manager('allopass');
	$criteria = new CriteriaCompo(new Criteria('ip',$ip,'='),'AND');
	$criteria->add(new Criteria('date',$now - $expiration_time,'>='),'AND');
	$criteria->add(new Criteria('action',$do,'='),'AND');
	$criteria->setLimit(1);
	
	$count = $am->getCount($criteria);
	
	if($count == 0)
	{
		list($SITE_ID,$DOC_ID,$AUTH) = AllopassChecker::getExplodedDocId();
	
		$str = '';
		
		$str .= '
		<div style="text-align: center;">
		<table cellpadding="0" cellspacing="0" style="border: 0px; width: 300px; text-align: center;">
	 <tr>
	  <td style="text-align: center; vertical-align: top; background-color: #FFF; width: 300px;">
	   <img src="http://www.allopass.com/imgweb/script/fr_uk/acces_title.jpg" alt="Logo" style="width: 300px; height: 25px;" />
	  </td>
	 </tr>
	 <tr>
	  <td style="text-align: center; width: 300px; height: 137px;">
	   <img src="http://www.allopass.com/show_top2.php4?SITE_ID='.$SITE_ID.'&amp;DOC_ID='.$DOC_ID.'&amp;LG=fr_uk" style="width: 300px; height: 137px;" alt="" />
	  </td>
	 </tr>
	 <tr>
	  <td style="text-align: right; vertical-align: top; background-color: #FFF;">
<img src="http://www.allopass.com/imgweb/script/fr_uk/acces_left.jpg" width="79" height="29" alt="" style="float:left" />';

		$flags = array('fr','be','ch','lu','de','uk','ca','au','nl','es','at','it','ie','hk','nz','se','no','pl','us');

		foreach($flags as $flag)
		{
			$str .= '
	 <a href="javascript:;" onclick="javascript:window.open(\'http://www.allopass.com/show_accessv2.php4?CODE_PAYS='.$flag.'&amp;SITE_ID='.$SITE_ID.'&amp;DOC_ID='.$DOC_ID.'&amp;LG=fr\',\'phone\',\'toolbar=0,location=0,directories=0,status=0,scrollbars=0,resizable=0,copyhistory=0,menuBar=0,width=300,height=340\');"><img  src="http://www.allopass.com/imgweb/common/flag_'.$flag.'.gif" alt="" style="width: 35px; height: 29px; border: 0px;" /></a>';
		}

	  $str .= '</td>
	 </tr></table></div><br />';
		
		$str .= 
		'<div style="text-align: center;">
			<form action="'.$CONFIG['site_url'].'/'.$form_action_page.'" method="post">
				<p>
					'.$lang['allopass_code'].'&nbsp;:&nbsp;
					<input type="text" name="CODE" value="" style="margin: 0;" />
					<input type="hidden" name="do" value="'.$do.'" />
					<input type="submit" name="OK" style="margin: 0;" />
				</p>
			</form>
		</div>
		';
		
		echo $str;
	}
	else
	{
		// this IP has already entered a valid allopass but it doesn't have used it
		header('Location: '.$CONFIG['site_url'].'/'.$first_premium_page);
	}
}
?>