<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

/* Small note on design:
 * 
 * Both links and categories are stored in the same database table.
 * The difference is that 'label' and 'href' fields are empty for categories.
 *
 * This is quite hacky but perfectly fits a simple two level design.
 *
 */ 
$my_name = "dirroll";
require dirname(__FILE__).'/class.dirroll.php';
$con =& Database::getInstance();

$url = 'index.php?cat=plugins&p=dirroll';

$dirroll = new DirRoll();

$action = !empty($_REQUEST['do']) ? $_REQUEST['do'] : NULL;
$page = !empty($_REQUEST['page']) ? $_REQUEST['page'] : NULL;
$err = '';

if ($page == 'edit_link' && !empty($_REQUEST['id']))
{
	include dirname(__FILE__).'/edit_link.php';
}
elseif ($page == 'edit_cat' && !empty($_REQUEST['id']))
{
	include dirname(__FILE__).'/edit_cat.php';
}
else
{
	$l_label = $l_title = $l_href = $l_lang = '';
	$c_title = '';
	
	# Ajout d'un lien
	if ($action == 'add_link')
	{
		$l_label = trim($_POST['l_label']);
		$l_title = trim($_POST['l_title']);
		$l_href = trim($_POST['l_href']);
		$l_lang = trim($_POST['l_lang']);
		
		if (!$l_label || !$l_href)
		{
			$err = $lang['dirroll_label_n_url_required'];
		}
		else
		{
			if ($dirroll->addLink($l_label,$l_href,$l_title,$l_lang) == false) {
				$err = $dirroll->con->error();
			} else {
				header('Location: '.$url);
				exit;
			}
		}
	}
	# Ajout d'un catgorie
	elseif ($action == 'add_cat')
	{
		$c_title = trim($_POST['c_title']);
		
		if ($c_title)
		{
			if ($dirroll->addCat($c_title) == false) {
				$err = $dirroll->con->error();
			} else {
				header('Location: '.$url);
				exit;
			}
		}
	}
	# Suppression
	elseif ($action == 'delete' && !empty($_GET['id']))
	{
		if ($dirroll->delEntry($_GET['id']) == false) {
			$err = $dirroll->con->error();
		} else {
			header('Location: '.$url);
			exit;
		}
	}
	# Classic ord
	if (isset($_POST['linkOrd']) && is_array($_POST['linkOrd']))
	{
		if ($dirroll->ordEntries($_POST['linkOrd']) === false) {
			$err = $dirroll->con->error();
		} else {
			header('Location: '.$url);
			exit;
		}
	}
	# DragNdrop
	if (!empty($_POST['dndSort']))
	{
		$linkOrd = array();
		foreach (explode(';',$_POST['dndSort']) as $k => $v) {
			$linkOrd[substr($v,3)] = $k;
		}
		
		if ($dirroll->ordEntries($linkOrd) === false) {
			$err = $dirroll->con->error();
		} else {
			header('Location: '.$url);
			exit;
		}
	}
	
	
	# Affichage ---
	buffer::str('<h2>'.$lang['dirroll_link_manager'].'</h2>');
	
	if ($err != '') {
		buffer::str(
		'<div class="erreur"><p><strong>'.$lang['dirroll_errors'].' :</strong></p>'.
		'<p>'.$err.'</p>'.
		'</div>'
		);
	}
	
	$strReq = 'SELECT link_id, label, href, title, lang, position '.
			'FROM '.$dirroll->table.' '.
			'ORDER BY position ';
	
	$rs = $con->select($strReq);
	
	buffer::str(
	'<p>'.$lang['dirroll_dragndroptochangepos'].'</p>'.
	'<form action="'.htmlentities($url).'" method="post">'.
	'<div id="sortlinks">'
	);
	while ($rs->fetch())
	{
		$link_id = $rs->f('link_id');
		$link_ord = $rs->f('position');
		
		$is_cat = !$rs->f('label') && !$rs->f('href');
		
		$i_label = ($is_cat) ? $rs->f('title') : $rs->f('label');
		
		if ($is_cat) {
			$del_msg = $lang['dirroll_sure_delete_cat'];
		} else {
			$del_msg = sprintf($lang['dirroll_sure_delete_this'],$lang['dirroll_link']);
		}
		
		buffer::str('<div class="sort" id="dnd'.$link_id.'">');
		
		buffer::str(
		'<p>'.($is_cat ? '<strong>' : '').
		'<a href="'.htmlentities($url).'&amp;do=delete&amp;id='.$link_id.'" '.
		'onclick="return window.confirm(\''.addslashes($del_msg).'\')">'.
		'<img src="'.$CONFIG['site_url'].'/themes/'.$CONFIG['theme_dir'].'/admin/images/delete.png" alt="'.$lang['dirroll_delete'].'" '.
		'title="'.$lang['dirroll_delete'].'" class="status" /></a>'
		);
		
		
		if ($is_cat) {
			buffer::str('<a href="'.htmlentities($url).'&amp;id='.$link_id.'&amp;page=edit_cat">'.
			$i_label.'</a>');
		} else {
			buffer::str('<a href="'.htmlentities($url).'&amp;id='.$link_id.'&amp;page=edit_link">'.
			$i_label.'</a>');
		}
		
		buffer::str(($is_cat ? '</strong>' : '').'</p>');
		
		if (!$is_cat)
		{
			buffer::str(
			'<p>'.
			htmlspecialchars($rs->f('href')).
			' - '.$rs->f('title').
			' ('.$rs->f('lang').')'.
			'</p>'
			);
		}
		
		buffer::str(
		'<p class="nojsfield"><label for="linkOrd'.$link_id.'" class="inline">'.$lang['dirroll_position'].' : </label>'.
		form::field(array('linkOrd['.$link_id.']','linkOrd'.$link_id),3,3,$link_ord).'</p>'
		);
		
		buffer::str('</div>');
	}
	buffer::str(
	'</div>'.
	'<p><input type="hidden" id="dndSort" name="dndSort" value="" />'.
	'<input type="submit" class="submit" value="'.$lang['dirroll_saveorder'].'" /></p>'.
	'</form>'
	);
	
	buffer::str(
	'<form action="'.htmlentities($url).'" method="post">'.
	'<fieldset><legend>'.$lang['dirroll_newlink'].'</legend>'.
	'<p class="field"><strong>'.
	'<label for="l_label" class="float">'.$lang['dirroll_label'].' : </label></strong>'.
	form::field('l_label',40,255,htmlspecialchars($l_label)).'</p>'.
	
	'<p class="field"><strong>'.
	'<label for="l_href" class="float">'.$lang['dirroll_url'].' : </label></strong>'.
	form::field('l_href',40,255,htmlspecialchars($l_href)).'</p>'.
	
	'<p class="field">'.
	'<label for="l_title" class="float">'.$lang['dirroll_description'].' ('.$lang['dirroll_optional'].') : </label>'.
	form::field('l_title',40,255,htmlspecialchars($l_title)).'</p>'.
	
	'<p class="field">'.
	'<label for="l_lang" class="float">'.$lang['dirroll_language'].' ('.$lang['dirroll_optional'].') : </label>'.
	form::field('l_lang',2,2,htmlspecialchars($l_lang)) . '</p>'.
	
	'<p>'.form::hidden('do','add_link').
	'<input type="submit" class="submit" value="'.$lang['dirroll_save'].'"/></p>'.
	'</fieldset>'.
	'</form>'
	);
	
	buffer::str(
	'<form action="'.htmlentities($url).'" method="post">'.
	'<br /><fieldset><legend>'.$lang['dirroll_newcat'].'</legend>'.
	'<p class="field"><strong>'.
	'<label for="c_title" class="float">'.$lang['dirroll_title'].' : </label></strong>'.
	form::field('c_title',40,255,htmlspecialchars($c_title)).'</p>'.
	
	'<p>'.form::hidden('do','add_cat').
	'<input type="submit" class="submit" value="'.$lang['dirroll_save'].'"/></p>'.
	'</fieldset>'.
	'</form>'
	);
	
	buffer::str(
	'<h3>'.$lang['dirroll_usage'].'</h3>'.
	'<p>'.$lang['dirroll_howtousage'].'</p>'.
	'<pre>&lt;{plugin name="'.$my_name.'" call="linkList"}&gt;</pre>');
}
?>
